#
/*
 *	Card reader/punch driver
*/

#include "../param.h"
#include "../conf.h"
#include "../user.h"


#define CSADDR	0177160

#define CLOSED	0
#define RDWAIT	1
#define RDING	2
#define RDERROR	3
#define RDEOF	4
#define	PNWAIT	011
#define	PNING	012
#define	PNERROR	013
#define	PNEOF	014

#define GO	01
#define PUNCH	02
#define PRINT	04
#define SEPRINT	010
#define NOREAD	020
#define INTENAB	0100
#define DONE	0200
#define	ERRCL	0400
#define ERROR	0100000
#define SS0	0004000
#define SS1	0010000
#define HS0	0020000
#define HS1	0040000

#define RDREQ	01
#define RDMULT	02
#define RDRDY	010
#define EMPTY	020
#define RDCHEK	040
#define INCHEK	0100
#define	ERRBIT1	0200
#define PNREQ	0400
#define PRREQ	01000
#define PNRDY	04000
#define FULL	010000
#define PNCHEK	020000
#define OUTCHEK	040000
#define	ERRBIT2	0100000

#define RDEOFCH	0202

#define CSRDPRI	30
#define CSPNPRI	30

#define RDHWAT	162
#define	RDLWAT	81
#define	PNHWAT	162
#define	PNLWAT	81

struct {
	int cstcr;
	int cstsr;
	char cstdrd;
	char cstdpn;
	int cstir;
	};

struct {
	int state;
	int rdspcnt;
	int rdclcnt;
	int rderrsw;
	int rdeofsw;
	struct {	int rdcc;
			int rdcf;
			int rdcl;
		} csrdq;
	int pnclcnt;
	int pnspcnt;
	int pncl80;
	int pnerrnm;
	struct {	int pncc;
			int pncf;
			int pncl;
		} cspnq;
	} cs11;

struct { int INT; };

csopen(dev,flag)
{
  if (cs11.state != CLOSED)
	{ u.u_error = ENXIO; return; }
  if (flag == 0)
	{
	cs11.rdclcnt = 0; cs11.rdspcnt = 0;
	csrdwait();
	}
  else
	{
	cs11.pnclcnt = 80; cs11.pnspcnt = 0;
	cs11.pncl80 = 0;
	cspnwait();
	}
}

csread()
{
  int register c;
  extern lbolt;

  do {
	spl4();
	while ((c=getc(&cs11.csrdq)) < 0)
	 {
	  switch(cs11.state)
	   {
	    case RDEOF:
		  spl0();
		  return;

	    case RDERROR:
		  sleep(&lbolt, CSRDPRI+1);

	    case RDWAIT:
		  csrdgo();

	    case RDING:
		  sleep(&cs11.csrdq, CSRDPRI+2);
	   }
         }
	if (cs11.state == RDWAIT && cs11.csrdq.rdcc < RDLWAT)
		csrdgo();
	spl0();
  } while (passc(csrdmap(c)) >= 0);
}

cswrite()
{
  int register c;
  extern lbolt;

  while((c = cpass()) >= 0)
   {
	while (putc(cspnmap(c), &cs11.cspnq))
		sleep(&lbolt, CSPNPRI+3);
cspnnogo:
	spl4();
	switch(cs11.state)
	 {
	  case PNERROR:
		if (cs11.pnerrnm)
		  {
			u.u_error = cs11.pnerrnm;
			spl0();
			return;
		  }
		sleep(&lbolt, CSPNPRI+4);

	  case PNWAIT:
		if (cspngo() == 0)
			{ spl0();
			  goto cspnnogo;
			}

	  case PNING:
		if (cs11.cspnq.pncc > PNHWAT)
			sleep(&cs11.cspnq, CSPNPRI+5);
	 }
	spl0();
    }
}

csint()
{
  int register c;
  register cstcr,cstsr;
  cstcr = &(CSADDR->cstcr);
  cstsr = &(CSADDR->cstsr);

  switch(cs11.state)
  { case RDEOF:
    case RDERROR:
    case RDWAIT:

	cstcr->INT = ERRCL;
	wakeup(&cs11.csrdq);
	return;

    case RDING:

      if (cstsr->INT & RDREQ)
      {
	if (cstcr->INT & ERROR)
	  {
	    cstcr->INT =| ERRCL;
	    cs11.rderrsw++;
	  }

	c = ((cstsr->INT & RDMULT) ? 0200: 0);
	c =| CSADDR->cstdrd;
	c =& 0377;

	if (cs11.rdclcnt == 0)
	{ if (c == ' ') cs11.rdspcnt++;
	  else { if (c == RDEOFCH) cs11.rdeofsw++;
		 else putc(c, &cs11.csrdq);
	       }  
	}

	else
	{ if (c == ' ') cs11.rdspcnt++;
	  else {
		if (cs11.rdeofsw)	{ putc(RDEOFCH, &cs11.csrdq);
					  cs11.rdeofsw = 0;
				        }
		if (cs11.rdspcnt)	{ do putc(' ', &cs11.csrdq);
					   while (--cs11.rdspcnt);
					}
		putc(c, &cs11.csrdq);
		}
	}
	if (++cs11.rdclcnt == 80)
	{ if (cs11.rdeofsw) { cs11.state = RDEOF;
				cstcr->INT = SS0|NOREAD|GO;
				  }
	  else putc('\n', &cs11.csrdq);
	  wakeup(&cs11.csrdq);
	}
      }

      else if (cstcr->INT & DONE)
      {
	if (cs11.rderrsw || cstcr->INT & ERROR)
		csrderr();
	else if (cs11.csrdq.rdcc > RDHWAT)
		csrdwait();
	else
		csrdgo();
      }

      else
      {
	  csrderr();
	  wakeup(&cs11.csrdq);
      }
      return;

    case PNERROR:
    case PNWAIT:

      cstcr->INT = ERRCL;
      wakeup(&cs11.cspnq);
      return;

    case PNING:

      if (cstsr->INT & PNREQ || cstcr->INT & DONE)
      {
	cspngo();
      }

      else
      {
	cspnerr(0);
      }
      if ((cs11.state == PNERROR) || (cs11.cspnq.pncc < PNLWAT))
	wakeup(&cs11.cspnq);
      return;
  }
}

csclose(dev,flag)
{
  extern lbolt;

  if (flag == 0)
    {
	while (getc(&cs11.csrdq) >= 0) ;
    }
  else
    {
	if (cs11.pnerrnm)
		while(getc(&cs11.cspnq) >= 0) ;
	else
		putc('\n', &cs11.cspnq);
	while (cs11.cspnq.pncc)
	{
	spl4();
	switch(cs11.state)
	 {
	  case PNERROR:
		sleep(&lbolt, CSPNPRI+6);

	  case PNWAIT:
		cspngo();

	  case PNING:
		sleep(&cs11.cspnq, CSPNPRI+7);
	 }
	spl0();
	}
	cs11.pnerrnm = 0;
    }
  CSADDR->cstcr = ERRCL|SS0|NOREAD|GO;
  cs11.state = CLOSED;
}

csrdgo()
{
  cs11.state = RDING;
  cs11.rdeofsw = cs11.rderrsw = cs11.rdspcnt = cs11.rdclcnt = 0;
  CSADDR->cstcr = HS0|SS0|INTENAB|ERRCL|GO;
}
csrdwait()
{
  cs11.state = RDWAIT;
  CSADDR->cstcr = ERRCL|HS0|SS0;
}

csrderr()
{
  cs11.state = RDERROR;
  CSADDR->cstcr = ERRCL|HS0|SS0;
}

csrdmap(c)
{
  if ('A'<=c && c<='Z')
	return (c-'A'+'a');
  return(c);
}

cspngo()
{
  int register c;
  register cstcr,cstsr;
  cstcr = &(CSADDR->cstcr);
  cstsr = &(CSADDR->cstsr);

  cstcr->INT =| ERRCL;

  if (cstsr->INT & PNREQ)
  {
    if (cstcr->INT & DONE || cs11.pnclcnt >= 80)
	{
	cspnerr(EIO);
	return(0);
	}
    cstcr->INT = HS1|SS0|INTENAB|NOREAD|ERRCL;
cspnreq:
    if(cs11.pnspcnt)
      {
	CSADDR->cstdpn = ' ';
	cs11.pnclcnt++;
	cs11.pnspcnt--;
	cs11.state = PNING;
      }
    else if ((c = getc(&cs11.cspnq)) < 0)
      {
	cspnwait();
      }
    else
      {
	if (c == '\n')
	{
	if (cs11.pncl80) cs11.pncl80 = 0;
	else cs11.pnspcnt = 80 - cs11.pnclcnt;
	goto cspnreq;
	}
	CSADDR->cstdpn = c;
	cs11.pncl80 = (++cs11.pnclcnt == 80);
	cs11.state = PNING;
      }
    return(1);
  }
  else
  {
    if (cs11.cspnq.pncc == 0)
      {
	cspnwait();
      }
    else if (cstcr->INT & DONE)
      {
	if (cs11.pnclcnt != 80 && cs11.pnclcnt != 0)
	{
	  cspnerr(ENXIO);
	  return(0);
	}
	c = HS1|SS0|INTENAB|NOREAD|ERRCL|GO;
	if (cstsr->INT & PNRDY)
	{
	   c =| PUNCH;
	   cs11.pnclcnt = cs11.pnspcnt = 0;
	}
	cstcr->INT = c;
	cs11.state = PNING;
      }
    else
      {
	cspnerr(0);
      }
    return(0);
  }
}

cspnwait()
{
  cs11.state = PNWAIT;
  CSADDR->cstcr = ERRCL|HS1|SS0;
}

cspnerr(type)
{
  cs11.state = PNERROR;
  cs11.pnerrnm = type;
  CSADDR->cstcr = ERRCL|HS1|SS0;
}

cspnmap(c)
{
  if ('a'<=c && c<='z')
	return(c-'a'+'A');
  return(c);
}
