#
/*
 */

/*
 *   KL/DL-11 driver
 */
#include "../param.h"
#include "../conf.h"
#include "../user.h"
#include "../tty.h"
#include "../proc.h"

/* base address */
#define	KLADDR	0177560	/* console */
#define	KLBASE	0176500	/* kl and dl11-a */
#define	DLBASE	0175610	/* dl-e */
#define	NKL11	1
#define	NDL11	2
#define DSRDY	02
#define	RDRENB	01
#define FRERROR 020000

struct	tty kl11[NKL11+NDL11];

struct jl11 {		/* state != 0 -> no KL dev, use jlxin,jlrint */
	int	jlstate;
	int	jltim;
	struct clist jlin;
	struct clist jlout;
} jl11[NDL11];

struct klregs {
	int klrcsr;
	int klrbuf;
	int kltcsr;
	int kltbuf;
}

klopen(dev, flag)
{
	register char *addr;
	register struct tty *tp;
	register int kn;
	if((kn = dev.d_minor) >= NKL11+NDL11) {
		u.u_error = ENXIO;
		return;
	}
	tp = &kl11[kn];
	if (kn >= NKL11)
		if (jl11[kn-NKL11].jlstate != 0) {
			u.u_error = ENODEV;
			return;
		}
	if (u.u_procp->p_ttyp == 0) {
		u.u_procp->p_ttyp = tp;
		tp->t_dev = dev;
	}
	/*
	 * set up minor 0 to address KLADDR
	 * set up minor 1 thru NKL11-1 to address from KLBASE
	 * set up minor NKL11 on to address from DLBASE
	 */
	addr = KLADDR + 8*kn;
	if(kn)
		addr =+ KLBASE-KLADDR-8;
	if(kn >= NKL11)
		addr =+ DLBASE-KLBASE-8*NKL11+8;
	tp->t_addr = addr;
	if ((tp->t_state&ISOPEN) == 0) {
		tp->t_state = ISOPEN|CARR_ON;
		tp->t_flags = XTABS|LCASE|ECHO|CRMOD;
	}
	addr->klrcsr =| IENABLE|DSRDY|RDRENB;
	addr->kltcsr =| IENABLE;
}

klclose(dev)
{
	register struct tty *tp;

	tp = &kl11[dev.d_minor];
	wflushtty(tp);
	tp->t_state = 0;
}

klread(dev)
{
	ttread(&kl11[dev.d_minor]);
}

klwrite(dev)
{
	ttwrite(&kl11[dev.d_minor]);
}

klxint(dev)
{
	register struct tty *tp;
	register int kn;

	if ((kn = dev.d_minor) >= NKL11 && jl11[kn-NKL11].jlstate != 0) {
		jlxint(dev);
		return;
	}
	tp = &kl11[kn];
	ttstart(tp);
	if (tp->t_outq.c_cc == 0 || tp->t_outq.c_cc == TTLOWAT)
		wakeup(&tp->t_outq);
}

klrint(dev)
{
	register int c, *addr;
	register struct tty *tp;
	int kn;

	if ((kn = dev.d_minor) >= NKL11 && jl11[kn-NKL11].jlstate != 0) {
		jlrint(dev);
		return;
	}
	tp = &kl11[kn];
	addr = tp->t_addr;
	c = addr->klrbuf;
	addr->klrcsr =| RDRENB;
	if ((c&0177)==0)
		addr->kltbuf = c;	/* hardware botch */
	if (c&FRERROR)
		c = -1;			/* break */
	ttyinput(c, tp);
}

klsgtty(dev, v)
int *v;
{
	register struct tty *tp;

	tp = &kl11[dev.d_minor];
	ttystty(tp, v);
}
