/ low core
/  on 11/45, must be in data space
.data

br4 = 200
br5 = 240
br6 = 300
br7 = 340

. = 0^.
	br	1f
	4

/ trap vectors
	trap; br7+0.		/ bus error
	trap; br7+1.		/ illegal instruction
	trap; br7+2.		/ bpt-trace trap
	trap; br7+3.		/ iot trap
pfailvec:
	pfail; br7+4.		/ power fail
	trap; br7+5.		/ emulator trap
	trap; br7+6.		/ system entry

. = 40^.
.globl	start, dump
1:	jmp	start
	jmp	dump


. = 60^.
	klin; br5
	klou; br5

. = 100^.
	kwlp; br6
	kwlp; br6

. = 120^.
	xyin; br5
. = 200^.
	lpou; br4

. = 220^.
	rkio; br5

. = 224^.
	tmio; br5

. = 230^.
	csio; br4

. = 240^.
	trap; br7+7.		/ programmed interrupt
	trap; br7+8.		/ floating point
	trap; br7+9.		/ segmentation violation

. = 254^.
	hpio; br5

. = 270^.
	csio; br4

/ floating vectors
. = 300^.
	dhin; br5
	dhou; br5
	dpin; br6+0.
	dpou; br6+0.
	bsin; br6+1.
	bsou; br6+1.
	dmin; br5+0.
	.=.+4		/to 340
	klin; br5+1.	
	klou; br5+1.
	klin; br5+2.
	klou; br5+2.

//////////////////////////////////////////////////////
/		interface code to C
//////////////////////////////////////////////////////

.globl	call, trap

.globl	_klrint
klin:	jsr	r0,call; _klrint
.globl	_klxint
klou:	jsr	r0,call; _klxint

.globl	_clock
kwlp:	jsr	r0,call; _clock

.globl	_lpint
lpou:	jsr	r0,call; _lpint

.globl	_rkintr
rkio:	jsr	r0,call; _rkintr

.globl	_hpintr
hpio:	jsr	r0,call; _hpintr

.globl	_tmintr
tmio:	jsr	r0,call; _tmintr

.globl	_dprint
dpin:	jsr	r0,call; _dprint
.globl	_dpxint
dpou:	jsr	r0,call; _dpxint

.globl	_bsrint
bsin:	jsr	r0,call; _bsrint
.globl	_bswint
bsou:	jsr	r0,call; _bswint

.globl	_dmint
dmin:	jsr	r0,call; _dmint


.globl	_dhrint
dhin:	jsr	r0,call; _dhrint
.globl	_dhxint
dhou:	jsr	r0,call; _dhxint

.globl	_xyint
xyin:	jsr	r0,call; _xyint

.globl	_csint
csio:	jsr	r0,call; _csint

pfail:
	mov	$pwrup,pfailvec
1:
	br	1b
pwrup:
	mov	$pfail,pfailvec
	.globl	start
	jmp	start		/start up again
