#
/*
 */

/*
 *	Memory special file
 *	minor device 0 is physical memory
 *	minor device 1 is kernel memory
 *	minor device 2 is EOF/RATHOLE
 *	minor device 3 is kernel i space memory
 *	minor device4-7for fast reads of sys tables
 */

#include "../param.h"
#include "../user.h"
#include "../conf.h"
#include "../seg.h"
#include "../buf.h"
#include "../proc.h"
#include "../text.h"
#include "../file.h"
#include "../inode.h"

#define	KISA	0172340

struct buf mmkbuf;

mmread(dev)
{
	register c, bn, on;
	char *p;
	int a, d;

	switch(dev.d_minor)
	{
	case 2:		/* eof rathole */
		return;

	default:
		u.u_error = ENXIO;
		return;

	case 4:		/* proc */
		mmkbuf.b_addr = &proc;
		c = sizeof proc;
		goto mmktab;

	case 5:		/* text */
		mmkbuf.b_addr = &text;
		c = sizeof text;
		goto mmktab;

	case 6:		/* file */
		mmkbuf.b_addr = &file;
		c = sizeof file;
		goto mmktab;

	case 7:		/* inode */
		mmkbuf.b_addr = &inode;
		c = sizeof inode;
		goto mmktab;

	case 0:
		goto mmkmem;

	case 1:		/* kmem */
		p = ka6 - 6;
		goto mmkmem;

	case 3:		/* imem */
		p = KISA;
		goto mmkmem;
	}

mmkmem:
	do {
		bn = lshift(u.u_offset, -6);
		on = u.u_offset[1] & 077;
		a = UISA->r[0];
		d = UISD->r[0];
		spl7();
		UISA->r[0] = bn;
		UISD->r[0] = 077406;
		if(dev.d_minor )
			UISA->r[0] = p->r[(bn>>7)&07] + (bn & 0177);
		c = fuibyte(on);
		UISA->r[0] = a;
		UISD->r[0] = d;
		spl0();
	} while(u.u_error==0 && passc(c)>=0);
	return;

	/* sys tables */
mmktab:
	if (u.u_count <= 0) {
		u.u_error = EIO;
		return;
	}
	c = min(c, u.u_count);
	spl7();
	iomove(&mmkbuf, 0, c, B_READ);
	spl0();
	return;
}

mmwrite(dev)
{
	register c, bn, on;
	int a, d;
	char *p;

	switch(dev.d_minor)
	{
	case 2:		/* eof rathole */
		c = u.u_count;
		u.u_count = 0;
		u.u_base =+ c;
		dpadd(u.u_offset, c);
		return;

	default:
		u.u_error = ENXIO;
		return;

	case 0:		/* mem */
		break;

	case 1:		/* kmem */
		p = ka6 - 6;
		break;

	case 3:		/* imem */
		p = KISA;
		break;
	}
	for(;;) {
		bn = lshift(u.u_offset, -6);
		on = u.u_offset[1] & 077;
		if ((c=cpass())<0 || u.u_error!=0)
			break;
		a = UISA->r[0];
		d = UISD->r[0];
		spl7();
		UISA->r[0] = bn;
		UISD->r[0] = 077406;
		if(dev.d_minor)
			UISA->r[0] = p->r[(bn>>7)&07] + (bn & 0177);
		suibyte(on, c);
		UISA->r[0] = a;
		UISD->r[0] = d;
		spl0();
	}
}
