#define TTY	0
#define H1200	1
#define MODONE	2
#define TEK	3
#define DTC	4
#define BYTSIZ	128
/* Hazeltine 1200 Dependent Codes */
#define H1200HME	013
#define H1200CLR	014
#define H1200DESTBL	020
/* Modular One Dependent Codes */
#define M1POSN		021
#define M1HME		022
#define M1CLR		034
#define M1DESTBL	040
#define M1TYPE1		042
#define M1LEADIN	0176

#define MAXFOLD		8

char	**screen;
char	*bend[MAXFOLD];
char	*buf[MAXFOLD];
char	*ptr;
char	blank	040;
char	bytbuf[BYTSIZ];
char	destbl	H1200DESTBL;
char	ibuf[512];
char	raw[513];
int	begin	1;
int	bytcnt;
int	column;
int	elite;
int	fin;
int	first	1;
int	fold;
int	form;
int	hiprint;
int	info2;
int	info[3];
int	length	88;
int	lexit();
int	line;
int	number;
int	peekc;
int	pbreak;
int	pnumber;
int	stop;
int	term;
int	type;
int	width	158;

main(argc, argv)
char **argv;
{
	register char *p;
	register t, u;
	int s;
	char fill[60];

	char *c2d();
	ptr = raw;
	*ptr = -1;
	buf[0] = ibuf;
	if((term = open("/dev/tty", 0)) < 0) error("/dev/tty");
	t = gtty(1, info);
	type = (info[2] >> 9) & 07;
	argv++;
	--argc;
	if(argc > 0 && argv[0][0] == '-' && argv[0][1] != 0) {
		p = argv[0];
		p++;
		while(*p) switch(*p++) {
			case 't':
				type = (*p++) - '0';
				t = 0;
				break;
			case 'n':
				number++;
				break;
			case 'b':
				p = c2d(p, &begin);
				break;
			case 'l':
				p = c2d(p, &length);
				break;
			case 'w':
				p = c2d(p, &width);
				break;
			case 'f':
				fold++;
				break;
			case 'e':
				elite++;
				break;
			case 's':
				stop = 1;
				break;
			case 'p':
				p = c2d(p, &pbreak);
				if(pbreak == 0) pbreak = 8;
				break;
			default:
				write(2, "Switch?\n", 8);
				exit(-1);
		}
		argv++;
		--argc;
	}
	if(t) {
		write(2, "Output not a tty\n", 17);
		exit(-1);
	}
	switch(type) {
		default:
			type = TTY;
		case TTY:
			if(width > 80) width = 80;
			if(length > 66) length = 66;
			break;

		case H1200:
			getcore();
			stop = !stop;
			break;

		case MODONE:
			blank = H1200DESTBL;
			destbl = M1DESTBL;
			getcore();
			stop = !stop;
			wctl(M1LEADIN);
			wctl(M1TYPE1);
			break;

		case TEK:
			if(width > 72) width = 72;
			if(length > 33) length = 33;
			stop = !stop;
			break;

		case DTC:
			if(!elite) {
				if(width > 132) width = 132;
				if(length > 66) length = 66;
			} else {
				if(width > 158) width = 158;
				if(length > 88) length = 88;
			}
			break;

	}
	if(length <= pbreak || width <= 0) {
		write(2,"Gag\n",4);
		exit();
	}
	settty();
	more:
	pnumber = 1;
	if(argc > 0) {
		if(argv[0][0] == '-' && argv[0][1] == 0) fin = 0;
		else if((fin = open(argv[0], 0)) < 0) error(argv[0]);
		--argc;
		argv++;
	}
	pbreak =+ pbreak&01;
	wbyt('\r');
	while(--begin && getline());
	while(s = getline()) {
		for(t = 0; t < s; t++) {
			if(line == 0) {
				if(!first && stop) {
					rpd:
					read(term, fill, 60);
					if(fill[0] == 'r') {
						reprint();
						goto rpd;
					}
				}
				home(first);
				for(u = pbreak/2; u--; line++) wctl('\n');
			}
			putline(buf[t]);
			wctl('\n');
			line++;
			if(line >= length - pbreak/2)
				for(u = pbreak/2; u--; line++) wctl('\n');
			if(!fold) break;
			if(line >= length) {
				line = 0;
				if(stop) wbyt('\r');
				dbyt();
			}
		}
		if(form) {
			while(line <= length) {
				putline("");
				wctl('\n');
				line++;
			}
		}
		first = 0;
		form = 0;
		if(line >= length) {
			line = 0;
			if(stop) wbyt('\r');
			dbyt();
		}
	}
	if(line) while(line <= length) {
		if(argc <= 0 && line > hiprint) break;
		putline("");
		wctl('\n');
		line++;
	}
	line = 0;
	wbyt('\r');
	dbyt();
	if(fin) close(fin);
	begin = 1;
	if(argc > 0) goto more;
	lexit();
}

getcore()
{
	register char *p;
	register i, t;

	if(width > 80) width = 80;
	if(length > 22) length = 22;
	screen = sbrk((length + 1) * 2);
	p = sbrk((width + 4) * (length + 1));
	for(i = 0; i <= length; i++) {
		screen[i] = p;
		p =+ width + 4;
	}
	p = screen[0];
	for(i = -1; ++i < width + 4; )
		for(t = -1; ++t < length + 1; ) *p++ = destbl;
}

settty()
{
	info2 = info[2];
	info[2] =& ~030;
	signal(2, lexit);
	stty(1,info);
}

getline()
{
	register char *p;
	register cnt, curb;
	int c, skip;
	int tabbing, hiline;

	for(cnt = 0; cnt < MAXFOLD && buf[cnt]; cnt++)
		bend[cnt] = buf[cnt];
	curb = 0;
	p = buf[0];
	tabbing = 0;
	hiline = 1;
	skip = 0;
	if(number) {
		getnum(pnumber++, p);
		p =+ 8;
		skip = 8;
	}
	cnt = skip;

	for(;;) {
		if(--tabbing >= 0) c = ' ';
		else c = getchar();
		switch(c) {
			case -1:
				return(0);

			case '\r':
				*p = 0;
				while(p > buf[curb] && (*p == ' ' || *p == 0))
					--p;
				*++p = 0;
				hiline = curb + 1;
				bend[curb] = p;
				curb = 0;
				p = bend[0];
				*p++ = c;
				for(cnt = 0; cnt < skip; cnt++) *p++ = ' ';
				tabbing = 0;
				break;

			case H1200CLR:
				form++;
			case '\n':
				*p = 0;
				while(p > buf[curb] && (*p == ' ' || *p == 0))
					--p;
				*++p = 0;
				return(hiline);

			case '\b':
				*p++ = c;
				--cnt;
				break;

			case '\t':
				tabbing = 8 - cnt % 8;
				break;

			case 0:
				break;

			default:
				*p++ = c;
				if(++cnt >= width) {
					*p = 0;
					while(p > buf[curb] && (*p == ' ' || *p == 0))
						--p;
					*++p = 0;
					bend[curb] = p;
					if((c = getchar()) == '\n') return(hiline);
					peekc = c;
					tabbing = 0;
					if(++curb >= MAXFOLD) {
						write(2, "\r\nToo many folds\r\n", 18);
						lexit();
					}
					if(buf[curb] == 0) {
						buf[curb] = sbrk(512);
						p = buf[curb];
					} else {
						p = bend[curb];
						if(p != buf[curb]) *p++ = '\r';
					}
					hiline = curb + 1;;
					for(cnt = 0; cnt < skip; cnt++) *p++ = ' ';
				}
				break;
		}
	}
}

getnum(xx, pp)
int xx;
{
	register char *p;
	register t, x;

	p = pp;
	x = xx;

	for(t = 0; t++ < 8; ) *p++ = ' ';
	--p; --p;
	do {
		*--p = (x % 10) + '0';

	} while(x =/ 10);
}

c2d(pp, ii)
char *pp;
int *ii;
{
	register char *p;
	register t;

	p = pp;
	t = 0;
	while(*p >= '0' && *p <= '9') t = t * 10 + *p++ - '0';
	*ii = t;
	return(p);
}

error(s)
{
	perror(s);
	write(1, "\r", 1);
	lexit();
}

lexit()
{
	info[2] = info2;
	stty(1,info);
	exit();
}

putline(ib)
{
	register char *i, *o;
	register char c;
	char myblank;
	int t, clr;

	i = ib;
	if(type == TTY || type == TEK) {
		while(*i) {
			wbyt(c = *i++);
			if(c == '\r') {
				column = 0;
				t = -1;
			} else if(c == '\b' && type == TEK)
					t =- 2;
		}
		wctl('\r');
		column = 0;
		return;
	}

	if(type == DTC) {
		for(t = 0; *i; t++) {
			if(*i == ' ') ;
			else if(*i == '\b') t =- 2;
			else if(*i == '\r') t = -1;
			else {
				dposn(t);
				wbyt(*i);
			}
			i++;
		}
		return;
	}
	myblank = destbl;
	clr = 0;
	o = screen[line];
	for(t = 0; *i; t++) {
		if((c = *i++) == ' ') c = myblank;
		if((c == blank && *o == destbl) ||
			(c == destbl && *o == blank)) c = *o;
		if(c == '\b') {
			t =- 2;
			o =- 2;
		} else if(c == '\r') {
			if(!clr) {
				clear(t, o);
				clr++;
			}
			myblank = blank;
			t = -1;
			o = screen[line];
			--o;
		} else if(*o != c) {
			hmposn(t);
			wbyt(c);
		}
		o++;
	}
	if(!clr) clear(t, o);
}

clear(tt, oo)
{
	register char *o;
	register t;

	o = oo;

	if(tt != 0 && line > hiprint) hiprint = line;
	for(t = tt; t < width; t++)
		if(*o++ != destbl) {
			hmposn(t);
			wbyt(destbl);
		}
}

dposn(cc)
{
	register t;
	register c;
	if((c = cc) == column) return;

	if(c <= 0) {
		if(column <= 0) return;
		wctl('\r');
		column = 0;
		return;
	}
	while(c > column && c - column <= 24 && (c%8) == 0) {
		if(column < 0) {
			wctl(blank);
			column = 1;
		}
		wctl(011);
		column =+ 8 - column%8;
	}
	if(c == column) return;
	if(c - column == 1) {
		wctl(blank);
		column++;
		return;
	}
	if(c - column == -1) {
		wctl('\b');
		--column;
		return;
	}
	if(c - column == 2) {
		wctl(blank);
		wctl(blank);
		column =+ 2;
		return;
	}
	if(c - column == -2 && column >= 2) {
		wctl('\b');
		wctl('\b');
		column =- 2;
		return;
	}
	if(c == 4) {
		if(column < 4) {
			masmov(3);
			wctl(blank);
			column = 4;
			return;
		}
		masmov(5);
		wctl('\b');
		column = 4;
		return;
	}
	if(c > 127) {
		if(column > 127) {
			if(column > c) {
				while(column != c) {
					wctl('\b');
					--column;
				}
				return;
			} else {
				while(column != c) {
					wctl(blank);
					column++;
				}
				return;
			}
		}
		masmov(127);
		while(column != c) {
			wctl(blank);
			column++;
		}
		return;
	}
	masmov(c);
}

masmov(i)
{
	wctl(033);
	wctl('T');
	wctl(i);
	column = i;
}

hmposn(c)
{
	register cur, want;

	if(c < 0) c = 0;
	if(c > 79) c = 79;

	if(column == c) return;
	if(type == MODONE) {
		wctl(M1LEADIN);
		wctl(M1POSN);
		if(c < 32) wctl(c + 96);
		else wctl(c);
		wctl(line + 96);
		column = c;
		return;
	}
	cur = column;
	want = c;
	if(cur > want && (cur - want) > want) wbyt('\r');

	for(cur = column; cur > want; --cur) wbyt('\b');
	for(cur = column; cur < want; cur++) wbyt(blank);
}

home(clr)
{
	register t, i;

	line = 0;
	if(type == TEK) {
		wctl(033);
		wctl(H1200CLR);
		for(t = 17; --t; ) wctl(06);
		column = 0;
		return;
	}
	if(type == H1200) {
		if(clr) wctl(H1200CLR);
		else wctl(H1200HME);
		column = 0;
		return;
	}
	if(type == MODONE) {
		wctl(M1LEADIN);
		if(clr) wctl(M1CLR);
		else wctl(M1HME);
		column = 0;
	}
}

reprint()
{
	register char c;
	register char *i;
	register u;

	if(type != MODONE && type != H1200) return;
	home(1);
	for(u = pbreak/2; u--; line++) wctl('\n');
	do {
		i = screen[line];
		for(u = 0; u <= width; u++) {
			if((c = *i++) != destbl) {
				hmposn(u);
				wbyt(c);
			}
		}
		wctl('\n');
		line++;
	} while(line < length - pbreak/2);
	for(u = pbreak/2; u--; line++) wctl('\n');
	wbyt('\r');
	dbyt();
}

wbyt(cc)
char cc;
{
	register char c;
	register allowed;

	allowed = (type == H1200 || type == MODONE);
	c = cc;
	if(type == MODONE && c == M1LEADIN) c = '`';
	if(c >= 041 && c <= 0176) {
		bytbuf[bytcnt++] = c;
		if(allowed) screen[line][column] = c;
		column++;
	} else  switch(c) {

		case H1200DESTBL:
		case M1DESTBL:
			bytbuf[bytcnt++] = c;
			if(allowed && c == destbl) screen[line][column] = c;
			column++;
			break;

		case '\b':
			if(column == 0) break;
			bytbuf[bytcnt++] = c;
			--column;
			break;

		case '\r':
			bytbuf[bytcnt++] = c;
			column = 0;
			break;

		default:
			if(allowed) screen[line][column++] = bytbuf[bytcnt++] = destbl;
			break;
	}
	if(bytcnt >= BYTSIZ) dbyt();
	if((type == MODONE || type == H1200) && column > 79) {
		if(type == MODONE) wctl('\b');
		column = 79;
	}
	if(type == TEK && column > 71) {
		wctl('\b');
		column = 71;
	}
	if(bytcnt >= BYTSIZ) dbyt();
	return;
}

wctl(c)
{
	bytbuf[bytcnt++] = c;
	if(bytcnt >= BYTSIZ) dbyt();
}

dbyt()
{
	write(1, bytbuf, bytcnt);
	bytcnt = 0;
}

getchar()
{
	register i;

	if(peekc) {
		i = peekc;
		peekc = 0;
		return(i);
	}
	if(*ptr == -1) {
		if((i = read(fin, raw, 512)) <= 0) return(-1);
		raw[i] = -1;
		ptr = raw;
	}
	return(*ptr++);
}
