/*
 *	Terminal interface to tape controler
 */
char *comtab[]{
	"wtm=",
	"fsf=",
	"bsf=",
	"fsr=",
	"bsr=",
	"rew",
	"off",
	0
};
char	tname[]	"/dev/smtx";

extern float atof();
extern int fout;
extern int errno;

int	com;
int	err;
int	fil;
int	arg[3];

main(argc,argv) int argc; char **argv; {
	register ic;
	fout = 2;
	if(argc <= 2 || argv[1][0]<'0' || argv[1][0]>'1' || argv[1][1]!=0) {
		printf("usage: tcon unit-number command ...\n");
		exit(1);
	}
	tname[8]=argv[1][0];
	fil= open(tname,2);
	tname[5]='r';
	if (fil <= 0) {
		if (errno == 6)
			printf("%s: in use\n", tname);
		else
			perror(tname);
		exit(1);
	}
	for (ic = 2; ic < argc; ic++) {
		if((com = lookup(argv[ic])) < 0) {
			printf("tcon: unknown command '%s'\n", argv[ic]);
			exit(1);
		}
		arg[0] = com;
		arg[1] = atof(&argv[ic][4]);
		if(stty(fil,arg) < 0) {
			err = errno;
			if (gtty(fil,arg) < 0) {
				errno = err;
				perror(tname);
			} else {
				geterr(arg, com);
			}
			exit(1);
		}
	}
	exit(0);
}

int lookup(str) char *str; {
	register int i,j;
	register char c;
	for(i=0; comtab[i] != 0; i++) {
	 for(j=0; (c = comtab[i][j]) == str[j] && c != '\0' && c != '=';j++);
		if(c == str[j])return(i);
	}
	return(-1);
}

geterr(v,n) int *v; {
	register stat;
	stat = v[0];
	if ((stat & 0100) == 0)
		puterr("off-line");
	else if (stat & 04 && n == 0)
		puterr("write-protected");
	else if (stat & 030000)
		puterr("non-recoverable parity error");
	else if (stat & 0400)
		puterr("'bad tape' error");
	else if (stat & 02000)
		puterr("end of tape reached");
	else printf("%s: error status %6o %6o %6o\n", tname, v[0],v[1],v[2]);
}
puterr(s) {
	printf("%s: %s\n", tname, s);
}

